/**
* vec class
* v 1.19.0
* 2015-2019
* Processing 3.5.3
* Vector class with a float precision
* @author @stanlepunk
* @see http://stanlepunk.xyz
* @see https://github.com/StanLepunK/Rope
*/
package rope.vector;
import rope.core.BigBangRope;
public abstract class vec extends BigBangRope {
	public int num;
	public float x,y,z,w = Float.NaN;
	public float a,b,c,d,e,f = Float.NaN;
	public float r,g = Float.NaN;
	public float s,t,p,q = Float.NaN;
	public float u,v = Float.NaN;
	
  public vec(int num) {
    this.num = num;
  }
  
  /**
  * @return the number of components
  */
  public int get_num() {
    return num;
  }
  
  /**
   * return single float component
   * @return float
   */
  public float x() {
    return x;
  }

  public float y() {
    return y;
  }

  public float z() {
    return z;
  }

  public float w() {
    return w;
  }
    
  public float a() {
    return a;
  }
    
  public float b() {
    return b;
  }

  public float c() {
    return c;
  }

  public float d() {
    return d;
  }

  public float e() {
    return e;
  }

  public float f() {
    return f;
  }

  public float r() {
    return r;
  }

  public float g() {
    return g;
  }

  public float s() {
    return s;
  }

  public float t() {
    return t;
  }

  public float p() {
    return p;
  }

  public float q() {
    return q;
  }

  public float u() {
    return u;
  }

  public float v() {
    return v;
  }
  
  /**
  array
  */
  /**
  * return the list of component
  * @return float []
  */
  public float [] array() {
    if(num == 2) {
      float array [] = {x,y};
      return array;
    } else if(num == 3) {
      float array [] = {x,y,z};
      return array;
    } else if(num == 4) {
      float array [] = {x,y,z,w};
      return array;
    } else if(num == 5) {
      float array [] = {a,b,c,d,e};
      return array;
    } else if(num == 6) {
      float array [] = {a,b,c,d,e,f};
      return array;
    } else return null ;
  }


  /**
  * max
  * find the min and the max value in the vector list
  * @return float
  */
  public float max() {
    float [] list = new float[num];
    if(num == 2) {
      list[0] = x;
      list[1] = y;
    } else if(num == 3) {
      list[0] = x;
      list[1] = y;
      list[2] = z;
    } else if(num == 4) {
      list[0] = x;
      list[1] = y;
      list[2] = z;
      list[3] = w;
    } else if(num == 5) {
      list[0] = a;
      list[1] = b;
      list[2] = c;
      list[3] = d;
      list[4] = e;
    } else if(num == 6) {
      list[0] = a;
      list[1] = b;
      list[2] = c;
      list[3] = d;
      list[4] = e;
      list[5] = e;
    } 
    return max(list);
  }
  /**
  * min
  * find the min and the max value in the vector list
  * @return float
  */
  public float min() {
    float [] list = new float[num];
    if(num == 2) {
      list[0] = x;
      list[1] = y;
    } else if(num == 3) {
      list[0] = x;
      list[1] = y;
      list[2] = z;
    } else if(num == 4) {
      list[0] = x;
      list[1] = y;
      list[2] = z;
      list[3] = w;
    } else if(num == 5) {
      list[0] = a;
      list[1] = b;
      list[2] = c;
      list[3] = d;
      list[4] = e;
    } else if(num == 6) {
      list[0] = a;
      list[1] = b;
      list[2] = c;
      list[3] = d;
      list[4] = e;
      list[5] = e;
    } 
    return min(list);
  }
}
